ctp = ctp or {} local ctp = ctp

ctp.AllowedClasses = {
	"player",
	"prop_",
	"npc_",
}

ctp.DisabledElements = {
	"CHudSuitPower",
	"CHudHealth",
	"CHudBattery",
	"CHudAmmo",
	"CHudSecondaryAmmo",
}

ctp.BoneList = {
	["pelvis"] = "ValveBiped.Bip01_Pelvis",
	["spine_1"] = "ValveBiped.Bip01_Spine",
	["spine_2"] = "ValveBiped.Bip01_Spine1",
	["spine_3"] = "ValveBiped.Bip01_Spine2",
	["spine_4"] = "ValveBiped.Bip01_Spine4",
	["neck"] = "ValveBiped.Bip01_Neck1",
	["head"] = "ValveBiped.Bip01_Head1",
	["right_clavicle"] = "ValveBiped.Bip01_R_Clavicle",
	["right_upper arm"] = "ValveBiped.Bip01_R_UpperArm",
	["right_forearm"] = "ValveBiped.Bip01_R_Forearm",
	["right_hand"] = "ValveBiped.Bip01_R_Hand",
	["left_clavicle"] = "ValveBiped.Bip01_L_Clavicle",
	["left_upper arm"] = "ValveBiped.Bip01_L_UpperArm",
	["left_forearm"] = "ValveBiped.Bip01_L_Forearm",
	["left_hand"] = "ValveBiped.Bip01_L_Hand",
	["right_thigh"] = "ValveBiped.Bip01_R_Thigh",
	["right_calf"] = "ValveBiped.Bip01_R_Calf",
	["right_foot"] = "ValveBiped.Bip01_R_Foot",
	["right_toe"] = "ValveBiped.Bip01_R_Toe0",
	["left_thigh"] = "ValveBiped.Bip01_L_Thigh",
	["left_calf"] = "ValveBiped.Bip01_L_Calf",
	["left_foot"] = "ValveBiped.Bip01_L_Foot",
	["left_toe"] = "ValveBiped.Bip01_L_Toe0",
	["none"] = "none",
}

ctp.HistoryCount = 10

local function EpoePrint(...)
	if not EPOE then print(...) return end
	local tbl = {...}
	for key, value in pairs(tbl) do
		if key ~= #tbl then
			EPOE.AddText(tostring(value)..", ")
		else
			EPOE.AddText(tostring(value).."\n")
		end
	end
end

local function FindPlayerByName(str)

	if str == "" or not str then return LocalPlayer() end

	for key, ply in pairs(player.GetAll()) do
		if ply:Nick():lower():find(str:lower()) then
			return ply
		end
	end
end

function ctp:Initialize()
	self.SmoothOrigin = self.SmoothOrigin or Vector(0)
	self.SmoothDirection = self.SmoothDirection or Vector(0)
	self.SmoothFOV = self.SmoothFOV or 0

	local vectors = {}

	for i=1, self.HistoryCount do
		table.insert(vectors, vector_origin)
	end

	self.PrevOrigin = self.PrevOrigin or Vector(0)
	self.PlyPosHistory = vectors
	self.PrevDirection = self.PrevDirection or Vector(0)
	self.DirectionHistory = vectors
	self.PrevFOV = self.PrevFOV or 0

	self.RelativeOriginSpeed = 1

	self.Direction = self.Direction or Vector(0)

	self.Roll = self.Roll or 0
	self.SmoothRoll = self.SmoothRoll or 0

	self.CVars = {}

	self:InitCVars()

	self:SetPlayer(FindPlayerByName(self:GetPlayerName()))
end

do -- HTTP Reload

	ctp.CTPURL = "http://customisablethirdperson.googlecode.com/svn/trunk/lua/autorun/client/ctp.lua"

	function ctp:ReloadFromInternet()
		if self.AllowReload then return end
		http.Get(self.CTPURL, "", function(content)
			MsgN("Reloading CTP from google code")
			RunStringEx(content, "CTP Reload")
			if self:IsEnabled() then
				self:Toggle()
				self:Toggle()
			end

			if self:IsMenuVisible() then
				self:ToggleMenu()
				self:ToggleMenu()
			end
		end)
		self.AllowReload = true
	end

	ctp:ReloadFromInternet()

	concommand.Add("ctp_reload", function() ctp.AllowReload = false ctp:ReloadFromInternet() ctp.AllowReload = true end)

end

do -- CVars

	function ctp:InitCVars()
		self:RegisterCVar("threshold_enabled", 0, "ThresholdEnabled", "boolean")
		self:RegisterCVar("threshold_radius", 0, "ThresholdRadius", "float")

		self:RegisterCVar("offset_relative", 1, "OffsetRelative", "boolean")
		self:RegisterCVar("offset_lock_z", 1, "ZLockEnabled", "boolean")

		self:RegisterCVar("offset_fov_zoom_distance_enabled", 0, "ZoomDistanceEnabled", "boolean")
		self:RegisterCVar("offset_fov_zoom_distance", 500, "ZoomDistance", "float")
		self:RegisterCVar("offset_fov_zoom_distance_min", 30, "MinZoomDistance", "float")
		self:RegisterCVar("offset_fov", 75, "UserFOV", "float")
		self:RegisterCVar("offset_right", 0, "Right", "float")
		self:RegisterCVar("offset_forward", -100, "Forward", "float")
		self:RegisterCVar("offset_up", 0, "Up", "float")

		self:RegisterCVar("smoother_origin", 0.1, "OriginSmoother", "float")
		self:RegisterCVar("smoother_direction", 0.1, "DirectionSmoother", "float")
		self:RegisterCVar("smoother_nodes_direction", 50, "NodeDirectionSmoother", "float")
		self:RegisterCVar("smoother_fov", 0.1, "FOVSmoother", "float")

		self:RegisterCVar("lerp_aim", 0, "AimLerp", "float")

		self:RegisterCVar("angles_roll_amount", 0, "RollAmount", "float")

		self:RegisterCVar("angles_limit", 0, "AngleLimitEnabled", "boolean")
		self:RegisterCVar("angles_limit_smooth", 0, "AngleLimitSmoothEnabled", "boolean")

		self:RegisterCVar("angles_pitch", 0, "UserPitch", "float")
		self:RegisterCVar("angles_yaw", 0, "UserYaw", "float")
		self:RegisterCVar("angles_roll", 0, "UserRoll", "float")

		self:RegisterCVar("target_enable", 0, "TargettingEnabled", "boolean")
		self:RegisterCVar("target_radius", 0, "TargetRadius", "float")
		self:RegisterCVar("target_lerp", 0.3, "TargetLerp", "float")
		self:RegisterCVar("target_fov", 40, "TargetFOV", "float")

		self:RegisterCVar("movement_lock_pitch", 0, "LockPitchEnabled", "boolean")

		self:RegisterCVar("movement_rtc_enable", 0, "RTCEnabled", "boolean")
		self:RegisterCVar("movement_rtc_yaw_offset", 0, "RTCYawOffset", "float")
		self:RegisterCVar("movement_rtc_turn_time", 0, "RTCTurnTime", "float")
		self:RegisterCVar("movement_rtc_walk_focus", 1, "WalkFocusEnabled", "boolean")

		self:RegisterCVar("hud_crosshair_enable", 0, "CrosshairEnabled", "boolean")
		self:RegisterCVar("hud_crosshair_distance", 32000, "CrosshairDistance", "float")
		self:RegisterCVar("hud_hide", 0, "HUDHidden", "boolean")
		self:RegisterCVar("hud_black_bars_enable", 0, "BlackBarsEnabled", "boolean")
		self:RegisterCVar("hud_black_bars_amount", 0, "BlackBarAmount", "float")

		self:RegisterCVar("nodes_place_enable", 0, "NodePlacerEnabled", "boolean")
		self:RegisterCVar("nodes_enable", 0, "NodesEnabled", "boolean")
		self:RegisterCVar("nodes_draw", 0, "DrawingNodesEnabled", "boolean")
		self:RegisterCVar("nodes_draw_spheres", 0, "DrawingNodeSpheresEnabled", "boolean")
		self:RegisterCVar("nodes_load_by_map_name", 0, "LoadByMapNameEnabled", "boolean")

		self:RegisterCVar("center_offset_forward", 0, "CenterOffsetForward", "float")
		self:RegisterCVar("center_offset_right", 0, "CenterOffsetRight", "float")
		self:RegisterCVar("center_offset_up", 0, "CenterOffsetUp", "float")

		self:RegisterCVar("bone_name", "head", "Bone", "string")

		self:RegisterCVar("trace_enable", 1, "TraceBlockEnabled", "boolean")
		self:RegisterCVar("trace_smooth", 1, "TraceBlockSmoothEnabled", "boolean")
		self:RegisterCVar("trace_forward", 20, "TraceForward", "float")
		self:RegisterCVar("trace_down", 0, "TraceDown", "float")

	end

	function ctp:GetCVarValue(name)
		return self[self.CVars[name]].GetVar()
	end

	function ctp:RegisterCVar(name, default, namefunc, type, dontsave)

		name = name:lower()
		type = type or "float"

		self.CVars[name] = {cvar = CreateClientConVar("cl_ctp_" .. name, default, not dontsave), type = type, dontsave = dontsave}

		local function GetVar()
			return
					type == "boolean" and self.CVars[name].cvar:GetBool() or
					type == "integer" and self.CVars[name].cvar:GetInt() or
					type == "float" and self.CVars[name].cvar:GetFloat() or
					type == "string" and self.CVars[name].cvar:GetString()
		end

		self.CVars[name].GetVar = GetVar

		self[(type == "boolean" and "Is" or "Get") .. namefunc] = function()
			return GetVar()
		end

	end

end

do -- Enable

	CreateClientConVar("ctp_enabled", "0", false, true)

	function _R.Player:IsCTPEnabled()
		return self:GetNWBool("ctp_enabled")
	end

	function ctp:Enable()

		-- For shit like ctp.Enable() to match gmod's way.
		self = self or ctp

		if self:IsEnabled() then return end

		MsgN("Enabling ctp")

		self:ResetSmoothers()

		local hooks = hook.GetTable().CalcView

		if hooks then
			self.OldHooks = table.Copy(hooks)

			for name in pairs(hooks) do
				hook.Remove("CalcView", name)
			end
		end

		hook.Add("CalcView", "ctp_CalcView", function(...) return ctp:CalcView(...) end)
		hook.Add("CalcVehicleThirdPersonView", "ctp_CalcVehicleThirdPersonView", function(_, ...) return ctp:CalcView(...) end)
		hook.Add("CreateMove", "ctp_CreateMove", function(ucmd) ctp:CreateMove(ucmd) end)
		hook.Add("HUDPaint", "ctp_HUDPaint", function() ctp:HUDPaint() end)
		hook.Add("HUDShouldDraw", "ctp_HUDShouldDraw", function(element) return ctp:HUDShouldDraw(element) end)
		hook.Add("ShouldDrawLocalPlayer", "ctp_ShouldDrawLocalPlayer", function() if ctp:IsEnabled() then return true end end)
		hook.Add("PlayerStepSoundTime", "ctp_PlayerStepSoundTime", function(...) return ctp:PlayerStepSoundTime(...) end)
		hook.Add("GUIMousePressed", "ctp_GUIMousePressed", function(...) return ctp:GUIMousePressed(...) end)
		hook.Add("GUIMouseReleased", "ctp_GUIMouseReleased", function(...) return ctp:GUIMouseReleased(...) end)

		self:SetPlayer(FindPlayerByName(self:GetPlayerName()))

		self.Enabled = true

		if self:IsLoadByMapNameEnabled() then
			self:LoadNodePreset(game.GetMap())
		end

		RunConsoleCommand("ctp_enabled", "1")
	end

	local function RemoveCTPHook(name)
		local unique = "ctp_" .. name
		local hooks = hook.GetTable()
		if hooks[name] and hooks[name][unique] then
			hook.Remove(name, unique)
		end
	end

	function ctp:Disable()

		self = self or ctp

		if not self:IsEnabled() then return end

		MsgN("Disabling ctp")

		if self.OldHooks then
			for name, func in pairs(self.OldHooks) do
				hook.Add("CalcView", name, func)
			end
		end

		RemoveCTPHook("CalcView")
		RemoveCTPHook("CalcVehicleThirdPersonView")
		RemoveCTPHook("CreateMove")
		RemoveCTPHook("HUDPaint")
		RemoveCTPHook("HUDShouldDraw")
		RemoveCTPHook("ShouldDrawLocalPlayer")
		RemoveCTPHook("PlayerStepSoundTime")
		RemoveCTPHook("GUIMousePressed")
		RemoveCTPHook("GUIMouseReleased")

		self.OldHooks = nil

		self:GetPlayer():SetEyeAngles(self:GetDirection():Angle())

		self.Enabled = false
		self.NodeView = false

		RunConsoleCommand("ctp_enabled", "0")
	end

	function ctp:IsEnabled()
		return self.Enabled
	end

	function ctp:Toggle()
		self = self or ctp

		if ctp:IsEnabled() then
			ctp:Disable()
		else
			ctp:Enable()
		end
	end

	function ctp:ShowMenu()
		if IsValid(ctp.Frame) then return end

		ctp.Frame = vgui.Create("ctp_MainFrame")
	end

	function ctp:CloseMenu()
		if IsValid(ctp.Frame) then ctp.Frame:Close() end
	end

	function ctp:IsMenuVisible()
		return IsValid(self.Frame)
	end

	function ctp:ToggleMenu()
		if ctp:IsMenuVisible() then
			ctp:CloseMenu()
		else
			ctp:ShowMenu()
		end
	end

	concommand.Add("ctp", function()
		ctp:Toggle()
	end)

	concommand.Add("ctp_toggle_menu", function()
		ctp:ToggleMenu()
	end)

	hook.Add( "PopulateToolMenu", "ctp_PopulateToolMenu", function()
		spawnmenu.AddToolMenuOption( "Options",
			"Visuals",
			"CTP",
			"CTP Options",    "",    "",
			function(panel)
				panel:AddPanel(vgui.Create("ctp_ContextMenu"))
			end
		)
	end)

end

do -- Presets

	function ctp:SaveCVarPreset(name, description)

		local tbl = {}

		tbl.name = name
		tbl.description = description or "none"
		tbl.cvars = {}

		for key, cvar in pairs(self.CVars) do
			if not cvar.dontsave then
				local var = cvar.GetVar()

				var = type(var) == "boolean" and (var == true and "1" or var == false and "0") or var

				tbl.cvars[key] = var
			end
		end

		file.Write("ctp/cvar_presets/" .. util.CRC(name) .. ".txt", TableToKeyValues(tbl))

	end

	function ctp:LoadCVarPreset(name)

		local tbl = {}

		for key, preset in pairs(file.Find("ctp/cvar_presets/*")) do
			if util.CRC(name) == preset:Replace(".txt", "") then
				tbl = KeyValuesToTable(file.Read("ctp/cvar_presets/" .. preset))
				break
			end
		end

		if not tbl.cvars then MsgN("CTP tried to load cvar preset '" .. name .. "' but it doesn't exist!") return end

		for key, value in pairs(tbl.cvars) do
			RunConsoleCommand("cl_ctp_" .. key, tostring(value))
		end

		self.CurrentCVarPreset = tbl

	end

	function ctp:GetCurrentCVarPreset()
		return self.CurrentCVarPreset
	end

	function ctp:DeleteCVarPreset(name)
		for key, preset in pairs(file.Find("ctp/cvar_presets/*")) do
			if util.CRC(name) == preset:Replace(".txt", "") then
				file.Delete("ctp/cvar_presets/" .. preset)
				break
			end
		end
	end

	function ctp:GetCVarPresets()
		local rtrn = {}

		for key, preset in pairs(file.Find("ctp/cvar_presets/*")) do
			local content = file.Read("ctp/cvar_presets/" .. preset)
			if file.Exists("ctp/cvar_presets/" .. preset) and content and content ~= "" then
				local preset = KeyValuesToTable(content)
				rtrn[preset.name] = preset.description ~= "none" and preset.description or ""
			end
		end

		return rtrn
	end

	function ctp:SaveNodePreset(name, description)

		local tbl = {}

		tbl.name = name
		tbl.description = description or "none"
		tbl.nodes = table.Sanitise(self.Nodes)

		file.Write("ctp/node_presets/" .. util.CRC(name) .. ".txt", TableToKeyValues(tbl))

	end

	function ctp:LoadNodePreset(name)

		local tbl = {}

		for key, preset in pairs(file.Find("ctp/node_presets/*")) do
			if util.CRC(name) == preset:Replace(".txt", "") then
				tbl = KeyValuesToTable(file.Read("ctp/node_presets/" .. preset))
				break
			end
		end

		if not tbl.nodes then MsgN("CTP tried to load node preset '" .. name .. "' but it doesn't exist!") return end

		for key, value in pairs(table.DeSanitise(tbl.nodes)) do
			table.insert(self.Nodes, value)
		end

		self.CurrentNodePreset = tbl

	end

	function ctp:GetCurrentNodePreset()
		return self.CurrentNodePreset
	end

	function ctp:DeleteNodePreset(name)
		for key, preset in pairs(file.Find("ctp/node_presets/*")) do
			if util.CRC(name) == preset:Replace(".txt", "") then
				file.Delete("ctp/node_presets/" .. preset)
				break
			end
		end
	end

	function ctp:GetNodePresets()
		local rtrn = {}

		for key, preset in pairs(file.Find("ctp/node_presets/*")) do
			local content = file.Read("ctp/node_presets/" .. preset)
			if file.Exists("ctp/node_presets/" .. preset) and content and content ~= "" then
				local preset = KeyValuesToTable(content)
				rtrn[preset.name] = preset.description ~= "none" and preset.description or ""
			end
		end

		return rtrn
	end

end

do -- Meta
	AccessorFunc(ctp, "PlayerName", "PlayerName")
	AccessorFunc(ctp, "Player", "Player")

	function ctp:GetPlayer()
		return IsValid(self.Player) and self.Player or LocalPlayer()
	end

	AccessorFunc(ctp, "Origin", "Origin")
	AccessorFunc(ctp, "PrevOrigin", "PrevOrigin")

	-- Max map grid size is 32000, so there's no need for the camera to go outside these boundaries. It also prevents INF and NAN
	function ctp:SetOrigin(a)
		self.Origin = Vector(math.Clamp(a.x, -32000, 32000), math.Clamp(a.y, -32000, 32000), math.Clamp(a.z, -32000, 32000))
	end

	AccessorFunc(ctp, "Direction", "Direction")
	AccessorFunc(ctp, "PrevDirection", "PrevDirection")
	AccessorFunc(ctp, "DesiredDirection", "DesiredDirection")
	function ctp:SetDirection(a)
--[[ 		local info = debug.getinfo(2, "Sln")
		if info then
			Msg(string.format( "\t%i: Line %d\t\"%s\"\t%s\n", 0, info.currentline, info.name, info.short_src ))
		end ]]
		self.Direction = Vector(math.Clamp(a.x, -1, 1), math.Clamp(a.y, -1, 1), math.Clamp(a.z, -1, 1))
	end



	AccessorFunc(ctp, "Angles", "Angles")
	function ctp:GetAngles()
		return self:GetDirection():Angle()
	end

	function ctp:GetPrevAngles()
		return self:GetPrevDirection():Angle()
	end

	AccessorFunc(ctp, "Roll", "Roll")

	AccessorFunc(ctp, "FOV", "FOV")
	AccessorFunc(ctp, "PrevFOV", "PrevFOV")

	AccessorFunc(ctp, "RelativeOriginSpeed", "RelativeOriginSpeed")

	function ctp:GetFrameTime()
		return math.min(FrameTime(), 0.05)
	end

	function ctp:GetPlayerPos()
		local bone = self:GetBone()
		local pos

		if bone ~= "none" and ctp.BoneList[bone] then
			pos = self:GetPlayer():GetBonePosition(self:GetPlayer():LookupBone(ctp.BoneList[bone]))
		else
			pos = self:GetPlayer():GetPos() + Vector(0,0,36)
		end

		pos = pos + ((Angle(0, self:GetPlayer():EyeAngles().p, 0):Forward() * -self:GetCenterOffsetRight()))
		pos = pos  + ((Angle(0, self:GetPlayer():EyeAngles().y, 0):Forward() * self:GetCenterOffsetForward()))
		pos = pos  + ((self:GetPlayer():EyeAngles():Up() * self:GetCenterOffsetUp()))

		return pos
	end

	function ctp:IsTargeting()
		return self.IsTargeting
	end

	function ctp:IsViewingFromNode()
		return self.NodeView
	end

	function ctp:ResetSmoothers()
		self.SmoothOrigin = self:GetPlayer():EyePos()
		self.SmoothDirection = self:GetPlayer():GetAimVector()
		self.SmoothFOV = self:GetPlayer():GetFOV()
	end

	function ctp:GetDirectionVelocity()
		return self.DirectionHistory[1] - self.DirectionHistory[self.HistoryCount-1]
	end

	function ctp:GetPlyPosDelta()
		return self.PlyPosHistory[1] - self.PlyPosHistory[self.HistoryCount-1]
	end

end

do -- CalcView

	function ctp:CalcView()

		self.Origin = self:GetPlayerPos()
		self.Direction = vector_origin
		self.Angles = self.Direction:Angle()
		self.FOV = 0

		self:Think()

		self.PrevOrigin = self.Origin
		self.PrevDirection = self.Direction
		self.PrevFOV = self.FOV

		table.insert(self.PlyPosHistory, self:GetPlayer():GetPos())

		if #self.PlyPosHistory > self.HistoryCount then
			table.remove(self.PlyPosHistory, 1)
		end

		local ply = LocalPlayer()

		return {
			origin = self.Origin,
			angles = self.Direction:Angle() + Angle(-self:GetUserPitch(), self:GetUserYaw(), self:GetUserRoll() + self.Roll),
			fov = self.FOV,
			vm_origin = ply:GetShootPos(),
			vm_angles = ply:EyeAngles(),
		}
	end

	function ctp:Think()

		if self:IsZoomDistanceEnabled() then
			self:CalcFOV()
		else
			self:SetFOV(self:GetUserFOV())
		end

		if not self:IsThresholdEnabled() then
			self:CalcOffsets()
		end

		if self:IsThresholdEnabled() then
			self:CalcThreshold()
		end

		self:CalcDirection()

		self:CalcRoll()

		--self:CalcNoise() it doesn't look good

		if self:IsTargettingEnabled() then
			self:CalcTargetting()
		end

		if self:IsTraceBlockEnabled() and self:IsTraceBlockSmoothEnabled() then
			self:CalcTraceBlock()
		end


		if self:GetTraceDown() > 0 then
			self:CalcDownTrace()
		end

		self.NodeView = false

		if self:IsNodesEnabled() then
			self:CalcNodes()
		end

		if self:IsAngleLimitEnabled() and self:IsAngleLimitSmoothEnabled() then
			self:CalcAngleLimit()
		end

		self:CalcShortcuts()

		self:CalcSmoothing()

		if self:IsAngleLimitEnabled() and not self:IsAngleLimitSmoothEnabled() then
			self:CalcAngleLimit()
		end

		if not self.MousePos and self:IsTraceBlockEnabled() and not self:IsTraceBlockSmoothEnabled() then
			self:CalcTraceBlock()
		end

		if self:GetPlyPosDelta():Length() > 10000 then
			self.SmoothOrigin = self:GetPlayerPos()
		end

		self:CalcDrag()
	end

	function ctp:CalcFOV()
		self:SetFOV(math.Clamp((-(self:GetPlayerPos() - self:GetPrevOrigin()):Length() + self:GetZoomDistance() )  / (self:GetZoomDistance() / 100), self:GetMinZoomDistance(), 75))
	end

	function ctp:CalcOffsets()

		local offset = vector_origin

		if self:IsOffsetRelative() then
			if self:IsZLockEnabled() then
				offset = offset + (self:GetPlayer():EyeAngles():Right() * self:GetRight())
				offset = offset + (self:GetPlayer():EyeAngles():Forward() * self:GetForward())
				offset = offset + (self:GetPlayer():EyeAngles():Up() * self:GetUp())
			else
				offset = offset + (Angle(0, self:GetPlayer():EyeAngles().p, 0):Forward() * -self:GetRight())
				offset = offset + (Angle(0, self:GetPlayer():EyeAngles().y, 0):Forward() * self:GetForward())
				offset = offset + (self:GetPlayer():EyeAngles():Up() * self:GetUp())
			end
		else
			offset = offset + Vector(-self:GetForward(), -self:GetRight(), self:GetUp())
		end

		self:SetOrigin(self:GetOrigin() + offset)

	end

	function ctp:CalcDirection()

		local lerp = self:GetAimLerp()/100*2

		local player = (self:GetPlayerPos() - self:GetPrevOrigin()):Normalize()
		local hitpos = (self:GetPlayer():GetEyeTraceNoCursor().HitPos - self:GetOrigin()):Normalize()
		local aim = self:GetPlayer():GetAimVector()

		local direction = Vector(0)

		if lerp < 1 then
			direction = LerpVector(lerp, player, hitpos)
		else
			direction = LerpVector(lerp - 1, hitpos, aim)
		end

		if IsValid(self:GetPlayer():GetVehicle()) or self:IsViewingFromNode() or self:IsRTCEnabled() and self:IsWalkFocusEnabled() and (self:GetPlayer():KeyDown(IN_MOVELEFT) or self:GetPlayer():KeyDown(IN_MOVERIGHT) or self:GetPlayer():KeyDown(IN_BACK) or self:GetPlayer():KeyDown(IN_FORWARD)) then
			direction = player
		end

		self:SetDirection(direction)

		self:SetDesiredDirection(direction)

	end

	function ctp:CalcRoll()
		self:SetRoll(math.Clamp(WorldToLocal(self:GetPlayer():GetVelocity(), Angle(0), Vector(0), self:GetAngles()).y * (-self:GetRollAmount() / 500), -90, 90))
	end

	function ctp:CalcNoise()
		self.SmoothNoise = self.SmoothNoise or vector_origin

		self.SmoothNoise = LerpVector(self:GetFrameTime() * 0.07, self.SmoothNoise, VectorRand() * (math.random() > 0.95 and 20 or 1))

		self:SetDirection(self:GetDirection() + self.SmoothNoise)
	end

	function ctp:CalcThreshold()
		local distance = self:GetPlayerPos():Distance(self:GetPrevOrigin()) / (self:GetThresholdRadius() * 0.5)

		distance = math.Round(math.Clamp(distance ^ 7-0.2, 0, 1), 5)

		self:SetRelativeOriginSpeed(distance)
	end

	local function FindValueInTable(tbl, target)
		for key, value in pairs(tbl) do
			if string.find(target, value) then
				return true
			end
		end
	end

	local distance = 300

	local function DistanceFromCenter(vec)
		local vec2 = vec:ToScreen()
		return math.Clamp((Vector(ScrW()/2, ScrH()/2, 0) - Vector(vec2.x, vec2.y, 0)):Length2D() / 1000, 0, 1)
	end

	local function CheckAim(vec)
		return ctp:GetPlayer():GetAimVector():DotProduct((vec - ctp:GetPlayer():EyePos()):Normalize() )
	end

	function ctp:CalcTargetting()

		local positions = Vector(0)
		local count = 0

		for key, entity in pairs(ents.FindInSphere(self:GetPlayerPos(), self:GetTargetRadius())) do
			if
				entity ~= self:GetPlayer() and
				entity ~= self:GetPlayer():GetVehicle() and
				entity:GetMoveType() == MOVETYPE_VPHYSICS and
				(entity:BoundingRadius() > 30 and
				FindValueInTable(self.AllowedClasses, entity:GetClass())) and
				hook.Call("PhysgunPickup", GAMEMODE, self:GetPlayer(), entity)
			then
				local point = entity:IsPlayer() and entity:GetShootPos() or entity:OBBCenter() + entity:GetPos()
				--if CheckAim(point) > 0.8 then
					positions = positions + point
					count = count + 1
				--end
			end
		end

		self.IsTargeting = false

		if count == 0 then return end

		self.IsTargeting = true

		local point = positions / count

		local multiplier = math.Clamp((DistanceFromCenter(point) * CheckAim(point)) + 0.5, 0.5, 1)

		self:SetDirection(LerpVector(multiplier * self:GetTargetLerp() / 100, self:GetDirection(), (point - self:GetOrigin()):Normalize()))

		self:SetFOV(self:GetTargetFOV() * multiplier)
	end

	--Thanks to ralle for telling me how to do this!
	--I'm kind of hacking the jump it makes by doing a lerp

	function ctp:CalcAngleLimit()

		local pos = self:GetPlayerPos()

		local a1 = self:GetDirection():Angle()
		local a2 = (pos - self:GetPrevOrigin()):Angle()
		local FOV = self:GetFOV() / 3
		local dir = a2:Forward() *-1

		local dot = math.Clamp(Angle(0, a1.y, 0):Forward():DotProduct( dir ), 0, 1)

		a1.p = a2.p + math.Clamp(math.AngleDifference(a1.p, a2.p), -FOV, FOV)
		FOV = FOV / (ScrH()/ScrW())
		a1.y = a2.y + math.Clamp(math.AngleDifference(a1.y, a2.y), -FOV, FOV)

		a1.p = math.NormalizeAngle(a1.p)
		a1.y = math.NormalizeAngle(a1.y)

		self:SetDirection(LerpVector(dot, a1:Forward(), dir * -1))
	end

	function ctp:CalcShortcuts()
		self.IsCTRLE = false
		if self:GetPlayer():KeyDown(IN_WALK) and self:GetPlayer():KeyDown(IN_USE) then
			self:SetOrigin(self:GetPlayerPos() + self:GetPlayer():GetAimVector() * -150)
			self:SetDirection((self:GetPlayerPos() - self:GetOrigin()):Normalize())
			self:SetFOV(75)

			self.SmoothDirection = self:GetDirection()
			self.SmoothOrigin = self:GetOrigin()
			self.SmoothFOV = self:GetFOV()

			self.IsCTRLE = true
		end
	end

	function ctp:CalcTraceBlock()
		local trace_forward = util.TraceLine({
			start = self:GetPlayerPos(),
			endpos = self:GetOrigin(),
			filter = {self:GetPlayer(), self:GetPlayer():GetVehicle()},
		})

		if trace_forward.Hit then
			self:SetOrigin(trace_forward.HitPos + (self:GetDirection() * self:GetTraceForward()))
			self.SmoothOrigin = self:GetOrigin()
		end
	end

	function ctp:CalcDownTrace()
		local trace_down = util.QuickTrace(self:GetOrigin(), vector_up * -self:GetTraceDown())

		if trace_down.Hit then
			local origin = self:GetOrigin()
			origin.z = 0
			self:SetOrigin(origin + Vector(0,0,trace_down.HitPos.z + self:GetTraceDown()))
		end
	end

	function ctp:CalcSmoothing()
		if self.IsCTRLE then return end

		if self:IsViewingFromNode() then
			self.SmoothOrigin = self:GetOrigin()
		else
			if self:IsThresholdEnabled() then
				self.SmoothOrigin = LerpVector(self:GetFrameTime() * (self:GetOriginSmoother() / (self:GetThresholdRadius() / 500)) * self:GetRelativeOriginSpeed(), self.SmoothOrigin, self:GetOrigin())
			elseif self:GetOriginSmoother() < 35 then
				self.SmoothOrigin = LerpVector(self:GetFrameTime() * self:GetOriginSmoother(), self.SmoothOrigin, self:GetOrigin())
			else
				self.SmoothOrigin = self:GetOrigin()
			end
		end

		if self:IsViewingFromNode() and self:GetNodeDirectionSmoother() < 35 then
			self.SmoothDirection = LerpVector(self:GetFrameTime() * self:GetNodeDirectionSmoother(), self.SmoothDirection, self:GetDirection())
		elseif not self:IsViewingFromNode() and self:GetDirectionSmoother() < 35 then
			self.SmoothDirection = LerpVector(self:GetFrameTime() * self:GetDirectionSmoother(), self.SmoothDirection, self:GetDirection())
			self.SmoothRoll = Lerp(self:GetFrameTime() * self:GetDirectionSmoother(), self.SmoothRoll, self:GetRoll())
		else
			self.SmoothDirection = self:GetDirection()
		end

		if self:GetFOVSmoother() < 35 then
			self.SmoothFOV = Lerp(self:GetFrameTime() * self:GetFOVSmoother(), self.SmoothFOV, self:GetFOV())
		else
			self.SmoothFOV = self:GetFOV()
		end

		self:SetOrigin(self.SmoothOrigin)
		self:SetDirection(self.SmoothDirection)
		self:SetFOV(self.SmoothFOV)
		self:SetRoll(self.SmoothRoll)

	end

end

do -- Dragging
	function ctp:GUIMousePressed(code)
		if code == MOUSE_LEFT then
			self.MousePos = Vector(gui.MouseX(), gui.MouseY(), 0)
			self.dragging = true
			self.DragDistance = self:GetOrigin():Distance(self:GetPlayerPos())
		end
		if code == MOUSE_RIGHT then
			self.MouseY = gui.MouseY()
			self.dragzooming = true
		end
	end
	
	function ctp:GUIMouseReleased()
		self.dragging = false
		self.dragzooming = false
	end

	ctp.CornerDistance = 10
	ctp.MousePos = vector_origin
	
	local xdelta = 0
	local ydelta = 0
	
	function ctp:CalcDrag()
	
		if not vgui.CursorVisible() or (not input.IsMouseDown(MOUSE_LEFT) and not input.IsMouseDown(MOUSE_RIGHT)) then
			xdelta = self:GetAngles().y
			ydelta = self:GetAngles().p
		return end
				
		if self.dragging then
			xdelta = (xdelta + (self.MousePos.x - gui.MouseX()) / 70)%360
			ydelta = (ydelta + (self.MousePos.y - gui.MouseY()) / 70)%360
			
			self:SetOrigin(self:GetPlayerPos() + Angle(ydelta, xdelta, 0):Forward() * -self.DragDistance)
			self:SetDirection((self:GetPlayerPos() - self:GetOrigin()):Normalize())
			
			self.SmoothOrigin = self:GetOrigin()
			self.SmoothDirection = self:GetDirection()
		end
		
		if self.dragzooming then
			self:SetOrigin(self:GetOrigin() + (self:GetDirection() * ((self.MouseY - gui.MouseY()) / 40) ))
			self.SmoothOrigin = self:GetOrigin()
		end

	end
end

do -- Nodes

	ctp.Nodes = ctp.Nodes or {}

	function ctp:CreateNode(point, size)
		MsgN("Adding node: " .. tostring(point))
		table.insert(self.Nodes, {size = size or 0, point = point})
	end

	function ctp:RemoveNode(point)
		for key, value in pairs(self.Nodes) do
			if value.point:Distance(point) < 100 then
				MsgN("Removing node: " .. tostring(value))
				self.Nodes[key] = nil
				return true
			end
		end
	end

	ctp.trail_material = Material( "cable/redlaser" )

	ctp.sphere_model = ClientsideModel("models/Combine_Helicopter/helicopter_bomb01.mdl")
	ctp.sphere_model:SetNoDraw(true)
	ctp.sphere_model:SetMaterial("models/debug/debugwhite")

	ctp.camera_model = ClientsideModel("models/Tools/camera/camera.mdl")
	ctp.camera_model:SetNoDraw(true)

	function ctp:DrawSphere(point, size, color)

		color = color or color_white

		self.sphere_model:SetRenderOrigin(point)
			render.SetBlend(0.2)
				render.SuppressEngineLighting(true)
					render.SetColorModulation(color.r/255, color.g/255, color.b/255)
						render.CullMode(MATERIAL_CULLMODE_CW)
						self.sphere_model:DrawModel()
						render.CullMode(MATERIAL_CULLMODE_CCW)
						self.sphere_model:DrawModel()
					render.SetColorModulation(1, 1, 1)
				render.SuppressEngineLighting(false)
			render.SetBlend(1)
		self.sphere_model:SetupBones()

		self.sphere_model:SetModelScale(Vector()/15*size)
	end

	function ctp:DrawEye(point, color)
		self.camera_model:SetRenderOrigin(point)
		self.camera_model:SetRenderAngles((self:GetPlayer():GetShootPos() - point):Angle())
		render.SetColorModulation(color.r/255, color.g/255, color.b/255)
		render.SuppressEngineLighting(true)
		self.camera_model:DrawModel()
		render.SuppressEngineLighting(false)
		self.camera_model:SetupBones()
	end

	function ctp:PostDrawOpaqueRenderables()
		if self:IsViewingFromNode() then return end

		if self.TempNode then
			local startpos = self.TempNode
			local endpos =  self:GetPlayer():GetEyeTrace().HitPos

			render.SetMaterial(self.trail_material)
				render.DrawBeam(startpos, endpos, 10, 0, color_white)

			self:DrawSphere(self.TempNode, (startpos-endpos):Length())
			self:DrawEye(self.TempNode, color_white)
		end

		if self:IsDrawingNodesEnabled() or self:IsNodePlacerEnabled() then
			for key, data in pairs(self.Nodes) do
				local color = self:GetPlayer():GetShootPos():Distance(data.point)-1 < data.size and Color(0, 255, 0, 255) or Color(255, 0, 0, 255)
				self:DrawEye(data.point, color)
				if self:IsDrawingNodeSpheresEnabled() then
					self:DrawSphere(data.point, data.size, color)
				end
			end
		end
	end
	hook.Add("PostDrawOpaqueRenderables", "ctp_PostDrawOpaqueRenderables", function() return ctp:PostDrawOpaqueRenderables() end)


	function ctp:CalcNodes()

		if table.Count(self.Nodes) == 0 then return end

		table.sort(self.Nodes,function(a,b)
			if a and b then return a.point:Distance(self:GetPlayer():EyePos()) < b.point:Distance(self:GetPlayer():EyePos()) end
		end)

		local closest

		for i = 1, #self.Nodes do
			if
				self.Nodes[i].point:Distance(self:GetPlayer():EyePos()) < self.Nodes[i].size and
				not util.TraceLine{start = self.Nodes[i].point, endpos = self:GetPlayer():EyePos()}.HitWorld
			then
				closest = self.Nodes[i]
			break end
		end

		if closest then
			self:SetOrigin(closest.point)
			self:SetDirection((self:GetPlayerPos() - closest.point):Normalize())

			self.NodeView = true
		end

	end

	ctp.press_hack = false

	function ctp:KeyPress(ply, key)

		if key == IN_BACK or key == IN_FORWARD or key == IN_MOVELEFT or key == IN_MOVERIGHT then
			self.Walking = true
		end

		if self.press_hack then return end

		if not self:IsNodePlacerEnabled() then return end

		if key == IN_ATTACK then
			self.TempNode = nil

			local trace = util.QuickTrace(self:GetPlayer():GetShootPos(), self:GetPlayer():GetAimVector() * 32000, self:GetPlayer())
			self.TempNode = trace.HitPos + (trace.HitNormal * 20)
			self:GetPlayer():EmitSound("buttons/button17.wav")
		end

		if key == IN_ATTACK2 then
			self.TempNode = nil

			if self:RemoveNode(self:GetPlayer():GetEyeTrace().HitPos) then
				self:GetPlayer():EmitSound("buttons/button16.wav")
			end
		end

		self.press_hack = true
		timer.Create("ctp_PressHack", 0.05, 1, function() self.press_hack = false end )
	end
	hook.Add("KeyPress", "ctp_KeyPress", function(ply, key) ctp:KeyPress(ply, key) end)

	ctp.release_hack = false

	function ctp:KeyRelease(ply, key)

		if key == IN_BACK or key == IN_FORWARD or key == IN_MOVELEFT or key == IN_MOVERIGHT then
			self.Walking = false
		end

		if self.release_hack then return end

		if not self:IsNodePlacerEnabled() then return end

		if self.TempNode and key == IN_ATTACK then
			self:CreateNode(self.TempNode, (self:GetPlayer():GetEyeTrace().HitPos - self.TempNode):Length())

			self.TempNode = nil

			self:GetPlayer():EmitSound("buttons/button17.wav")
		end

		self.release_hack = true
		timer.Create("ctp_ReleaseHack", 0.05, 1, function() self.release_hack = false end )
	end
	hook.Add("KeyRelease", "ctp_KeyRelease", function(ply, key) ctp:KeyRelease(ply, key) end)

end

do -- Move

	function ctp:CreateMove(ucmd)
		self.UCMD = ucmd

		if self:IsRTCEnabled() then self:CalcRelativeMovement() end

		--self:MouseToWorld()

		if self:IsLockPitchEnabled() then
			self:GetUCMD():SetViewAngles(Angle(0, self:GetUCMD():GetViewAngles().y, 0))
		end
	end

	function ctp:GetUCMD()
		return self.UCMD or self:GetPlayer():GetCurrentCommand()
	end

	ctp.smooth_yaw = 0
	ctp.moved_behind = false
	ctp.pitch = 0
	ctp.angle = Angle(0)

	function ctp:CalcRelativeMovement()
		local cmd = self:GetUCMD()

		if self.Walking and self:IsViewingFromNode() then
			self.TempYaw = self.smooth_yaw
		end

		if self:GetPlayer():KeyPressed(IN_BACK) then
			moved_behind = false
		end

		if self:GetPlayer():KeyDown(IN_BACK) then
			self.angle = (self:GetPrevAngles():Forward() *-1):Angle()
		end

		if self:GetPlayer():KeyDown(IN_FORWARD) or moved_behind then
			self.angle = self:GetPrevAngles():Forward():Angle()
		end

		if self:GetPlayer():KeyDown(IN_MOVELEFT) then
			self.angle = (self:GetPrevAngles():Right() *-1):Angle()
		end

		if self:GetPlayer():KeyDown(IN_MOVERIGHT) then
			self.angle = self:GetPrevAngles():Right():Angle()
		end

		self.pitch = math.Clamp(self.pitch + (cmd:GetMouseY() / (self:GetPlayer():GetInfo("sensitivity") * self:GetPlayer():GetInfo("m_pitch") < 0 and -50 or 50)),-89,89)
		self.smooth_yaw = math.ApproachAngle(self.smooth_yaw, self.angle.y, self:GetRTCTurnTime())

		if self:GetPlayer():KeyDown(IN_MOVELEFT) or self:GetPlayer():KeyDown(IN_MOVERIGHT) or self:GetPlayer():KeyDown(IN_BACK) or self:GetPlayer():KeyDown(IN_FORWARD) then
			cmd:SetForwardMove(1000)
			cmd:SetSideMove(0)

			if self:GetPlayerPos():Distance(self:GetPrevOrigin()) < 10 and self:GetPlayer():KeyDown(IN_BACK) then
				self.moved_behind = true
			end

			if moved_behind and self:GetPlayer():KeyDown(IN_FORWARD) then
				self.moved_behind = false
			end

			cmd:SetViewAngles(Angle(self.pitch, self.smooth_yaw+self:GetRTCYawOffset(), 0))
		end
	end

end

do -- HUD

	function ctp:HUDPaint()
		if self:IsCrosshairEnabled() then
			self:DrawCrosshair()
		end

		if self:IsBlackBarsEnabled() then
			self:DrawBlackBars()
		end

	end

	function ctp:DrawBlackBars()

		local amount = (-self:GetFOV() + 75) * self:GetBlackBarAmount()

		surface.SetDrawColor(0, 0, 0, 255)

		surface.DrawRect(0 , 0, ScrW(), amount)
		surface.DrawRect(0 , ScrH()-amount, ScrW(), amount)

	end

	function ctp:DrawCrosshair()

		local weapon = self:GetPlayer():GetActiveWeapon()
		local trace = util.QuickTrace(self:GetPlayer():GetShootPos(), self:GetPlayer():GetAimVector() * (IsValid(weapon) and weapon:GetClass() == "weapon_physgun" and math.min(self:GetCrosshairDistance(), 2500) or self:GetCrosshairDistance()), self:GetPlayer())

		local vec2 = trace.HitPos:ToScreen()

		if util.TraceLine({start = self:GetPrevOrigin(), endpos = trace.HitPos}).Fraction < 0.96 then
			surface.SetDrawColor(255, 100, 100, 255)
		else
			surface.SetDrawColor(255, 255, 255, 255)
		end

		local distance = 9 --* (-(trace.StartPos:Distance(trace.HitPos) / self:GetCrosshairDistance()) + 1)

		--EpoePrint(distance)
		local fatness = 2

		surface.DrawRect( vec2.x, vec2.y, fatness, fatness)

		surface.DrawRect( vec2.x, vec2.y + distance, fatness, fatness)
		surface.DrawRect( vec2.x, vec2.y - distance, fatness, fatness)

		surface.DrawRect( vec2.x + distance, vec2.y, fatness, fatness)
		surface.DrawRect( vec2.x - distance, vec2.y, fatness, fatness)
	end

	function ctp:HUDShouldDraw(element)
		if element == "CHudCrosshair" then
			return false
		end

		if self:IsHUDHidden() and table.HasValue(self.DisabledElements, element) then
			return false
		end
	end

end

do -- Mouse To World
	function ctp:MouseToWorld()
		local eye = self:GetPrevAngles()
		local fov = self:GetPrevFOV()
		local mousex = gui.MouseX()
		local mousey = gui.MouseY()
		local screenwidth = ScrW()
		local screenheight = ScrH()

		local yaw = eye.y+fov/2-(mousex/screenwidth)*fov
		local pitch = eye.p-(fov/2-(mousey/screenheight)*fov)*screenheight/screenwidth

		local hitpos = util.QuickTrace(self:GetPrevOrigin(), Angle(pitch, yaw, 0):Forward() * 1000, ply).HitPos

		--print(hitpos:Distance(self:GetPlayerPos()))

		debugoverlay.Cross(hitpos, 100, 0.1)

		return hitpos
	end

end

do --Misc hooks
	function ctp:PlayerStepSoundTime(ply, type, running)
		if ply ~= self:GetPlayer() then return end

		local running = self:GetPlayer():KeyDown(IN_SPEED)
		local walking = self:GetPlayer():KeyDown(IN_WALK)
		local sideways = not self:IsRTCEnabled() and (self:GetPlayer():KeyDown(IN_MOVELEFT) or self:GetPlayer():KeyDown(IN_MOVERIGHT))
		local forward = self:GetPlayer():KeyDown(IN_FORWARD)
		local back = not self:IsRTCEnabled() and self:GetPlayer():KeyDown(IN_BACK)

		local time = 240

		if running then
			time = 140
			if sideways then
				time = 200
			end
		end
		if walking then
			time = 285
			if forward then
				time = 390
			end
			if back then
				time = 330
			end
		end
		if sideways and not forward then
			time = time * 0.75
		end

		if not walking and not running and back then
			time = 200
		end

		return time
	end
end

ctp:Initialize()

hook.Add("InitPostEntity", "ctp_InitPostEntity", function() ctp:Initialize() end)

do -- GUI

	ctp.Spacing = 7

	ctp.FormFont = "MenuLarge"

	do -- ctp_Preset
		local PANEL = vgui.Register( "ctp_Preset", {}, "DPanel" )

		function PANEL:Init()
			self.choice = vgui.Create("DMultiChoice", self)
			self.choice.TextEntry:SetEnterAllowed(true)

			self.choice.TextEntry.OnEnter = function()
				self.presetname = self.choice.TextEntry:GetValue()
			end

			self.choice.OnCursorEntered = function()
				self.choice:RequestFocus()
			end

			self.choice.OnCursorExited = function()
				self.choice:KillFocus()
			end

			self.choice.OnSelect = function(_,_,value)
				self.presetname = value

				self.currentdata = self:GetType() == "cvar" and ctp:GetCVarPresets()[value] or self:GetType() == "nodes" and ctp:GetNodePresets()[value]

				if self.currentdata then
					self.choice:SetTooltip(self.currentdata)
				else
					self.choice:SetTooltip([[This preset has no description.
					You can make a description by typing it after a semicolon like so:
					valve thirdperson;this is just like the valve thirdperson camera!
					where the everything before " ; " is the name and everything after is the description]])
				end
			end

			self.save = vgui.Create("DSysButton", self)
			self.save:SetChar("a")
			self.save:NoClipping(true)
			self.save:SetTooltip("Save")
			self.save.DoClick = function()
				if self.presetname then
					MsgN("Saving preset '" .. self.presetname .. "'")
					local name, description = unpack(string.Explode(";", self.presetname))
					description = description or self.currentdata
					if self:GetType() == "cvar" then
						ctp:SaveCVarPreset(name, description)
					elseif self:GetType() == "nodes" then
						ctp:SaveNodePreset(name, description)
					end
					self.choice:Clear()
					self:Refresh()
				end
			end

			self.load = vgui.Create("DSysButton", self)
			self.load:SetChar("7")
			self.load:NoClipping(true)
			self.load:SetTooltip("Load")
			self.load.DoClick = function()
				if self.presetname then
					MsgN("Loading preset '" .. self.presetname .. "'")
					if self:GetType() == "cvar" then
						ctp:LoadCVarPreset(self.presetname)
					elseif self:GetType() == "nodes" then
						ctp:LoadNodePreset(self.presetname)
					end
				end
			end

			self.delete = vgui.Create("DSysButton", self)
			self.delete:SetType("close")
			self.delete:NoClipping(true)
			self.delete:SetTooltip("Delete")
			self.delete.DoClick = function()
				if self.presetname then
					MsgN("Deleting preset '" .. self.presetname .. "'")
					if self:GetType() == "cvar" then
						ctp:DeleteCVarPreset(self.presetname)
					elseif self:GetType() == "nodes" then
						ctp:DeleteNodePreset(self.presetname)
					end
					self.choice:Clear()
					self:Refresh()
				end
			end

		end

		AccessorFunc(PANEL, "Type", "Type")

		function PANEL:Refresh()

		end

		function PANEL:AddTable(tbl)
			for name, description in pairs(tbl) do
				self.choice:AddChoice(name, description ~= "" and description)
				if self:GetType() == "cvar" and ctp:GetCurrentCVarPreset() and ctp:GetCurrentCVarPreset().name == name then
					self.choice:ChooseOption(name)
				elseif self:GetType() == "nodes" and ctp:GetCurrentNodePreset() and ctp:GetCurrentNodePreset().name == name  then
					self.choice:ChooseOption(name)
				end
			end
		end

		function PANEL:PerformLayout()
			self.delete:SetWide(20)
			self.delete:AlignTop(ctp.Spacing)
			self.delete:AlignRight(ctp.Spacing)
			self.delete:SetTall(self:GetTall() - (ctp.Spacing * 2))

			self.save:SetWide(20)
			self.save:AlignTop(ctp.Spacing)
			self.save:MoveLeftOf(self.delete, ctp.Spacing)
			self.save:SetTall(self:GetTall() - (ctp.Spacing * 2))

			self.load:SetWide(20)
			self.load:AlignTop(ctp.Spacing)
			self.load:MoveLeftOf(self.save, ctp.Spacing)
			self.load:SetTall(self:GetTall() - (ctp.Spacing * 2))

			self.choice:AlignTop(ctp.Spacing)
			self.choice:AlignLeft(ctp.Spacing)
			self.choice:StretchRightTo(self.load, ctp.Spacing)
			self.choice:SetTall(self:GetTall() - (ctp.Spacing * 2))

		end
	end

	do -- ctp_Form
		local PANEL = vgui.Register( "ctp_Form", {}, "DForm" )

		function PANEL:Init()
			self:SetSize(150, 150)
			self.Label:NoClipping(true)

			self:SetSpacing(ctp.Spacing)
			self:SetPadding(ctp.Spacing)
		end

		function PANEL:PerformLayout()
			DForm.PerformLayout(self)
			self.Label:SetPos(-2,-5)
			self.Label:SetFont(ctp.FormFont)
		end

		function PANEL:Paint()
			local s = ctp.Spacing / 2
			draw.RoundedBox(6, 0, 0, self:GetWide(), self:GetTall(), Color(50,50,50, 120))
			draw.RoundedBox(6, s, s, self:GetWide()-(s*2), self:GetTall()-(s*2), Color(81, 81, 81))
		end
	end

	do -- ctp_Slider
		local PANEL = vgui.Register( "ctp_Slider", {}, "DNumSlider" )

		function PANEL:Init( )
			self:CopyHeight( self.Wang )

			self.Slider:SetTall( 13 )

			self:SetDecimals(1)
		end

		function PANEL:PerformLayout( )
			self.Label:SetPos( 0, 0 )
			self.Label:CenterVertical( )

			self.Wang:SizeToContents( )
			self.Wang:SetWide(40)
			self.Wang:SetPos( 0, 0 )
			self.Wang:AlignRight( 0 )

			self.Slider:CenterVertical( )
			self.Slider:MoveRightOf( self.Label, ctp.Spacing )
			self.Slider:StretchRightTo( self.Wang, ctp.Spacing )
			self.Slider:SetSlideX( self.Wang:GetFraction( ) )
		end

		function PANEL:SetText( str )
			DNumSlider.SetText( self, str )

			self.Label:SizeToContents( )
			self:InvalidateLayout( )
		end
	end

	do -- ctp_VectorSliders
		local PANEL = vgui.Register("ctp_VectorSliders", {}, "ctp_Form")

		function PANEL:Init()
			self.xslider = vgui.Create("ctp_Slider", self)
			self:AddItem(self.xslider)

			self.yslider = vgui.Create("ctp_Slider", self)
			self:AddItem(self.yslider)

			self.zslider = vgui.Create("ctp_Slider", self)
			self:AddItem(self.zslider)

			self.reset = vgui.Create("DButton", self)
			self.reset:SetText("reset")
			self:AddItem(self.reset)

			self.BaseClass.Init(self)
		end

		function PANEL:SetText(title, x, y, z, tooltip)
			self:SetName(title)
			self.xslider:SetText(x)
			self.yslider:SetText(y)
			self.zslider:SetText(z)

			self:SetTooltip(tooltip)
		end

		function PANEL:SetMinMax(xmin, xmax, ymin, ymax, zmin, zmax)
			self.xslider:SetMin(not xmax and -xmin or xmin)
			self.xslider:SetMax(xmax or xmin)

			self.yslider:SetMin(ymin or -xmin)
			self.yslider:SetMax(ymax or xmin)

			self.zslider:SetMin(zmin or -xmin)
			self.zslider:SetMax(zmax or xmin)
		end

		function PANEL:SetCVars(x, y, z)
			x = "cl_ctp_" .. x
			y = "cl_ctp_" .. y
			z = "cl_ctp_" .. z

			self.xslider:SetConVar(x)
			self.yslider:SetConVar(y)
			self.zslider:SetConVar(z)

			self.reset.DoClick = function()
				RunConsoleCommand(x, 0)
				RunConsoleCommand(y, 0)
				RunConsoleCommand(z, 0)
			end
		end
	end

	do -- ctp_MainFrame

		do -- ctp_SheetBase
			local PANEL = vgui.Register("ctp_SheetBase", {}, "DPanelList")

			function PANEL:Init()
				self:EnableHorizontal(false)
				self:EnableVerticalScrollbar(true)
				self:SetPadding(ctp.Spacing)
				self:SetSpacing(ctp.Spacing)

				self:Rebuild()
			end

		end

		do -- ctp_SheetOrigin
			local PANEL = vgui.Register("ctp_SheetOrigin", {}, "ctp_SheetBase")

			function PANEL:Init()
				self.offset = vgui.Create("ctp_VectorSliders", self)
					self:AddItem(self.offset)
					self.offset:SetMinMax(1000)
					self.offset:SetCVars("offset_right", "offset_forward", "offset_up")
					self.offset:SetText("Offset", "X", "Y", "Z",
						[[This controls the camera offset.
						It can be relative to player position or world position.]]
					)

				self.trace = vgui.Create("ctp_Form", self)
					self:AddItem(self.trace)
					self.trace:SetName("Trace Block")

					self.trace:CheckBox("Enable Forward", "cl_ctp_trace_enable"):SetTooltip(
					[[Enables the trace block which will move the camera forward if
					something is in the way of the player and the camera]])

					self.trace:CheckBox("Smooth", "cl_ctp_trace_smooth"):SetTooltip(
					[[If this is checked, it will obey the position smoother]])

					self.trace:NumSlider("Forward", "cl_ctp_trace_forward", -100, 100, 2):SetTooltip(
					[[This is the how much forward the camera will go from the blocking point]])

					self.trace:NumSlider("Down Trace Length", "cl_ctp_trace_down", 0, 500, 2):SetTooltip(
					[[This will keep the camera from going too close to the ground.
					For instance if it's at 100, it will keep itself 100 units from ground]])

				self.threshold = vgui.Create("ctp_Form", self)
					self:AddItem(self.threshold)
					self.threshold:SetName("Threshold")

					self.threshold:CheckBox("Enable", "cl_ctp_threshold_enabled"):SetTooltip(
					[[If this is checked, the camera will stop following when it reaches the radius given]])

					self.threshold:NumSlider("Radius", "cl_ctp_threshold_radius", 0, 2000, 0):SetTooltip(
					[[This is the radius of the threshold camera.]])

				self.misc = vgui.Create("ctp_Form", self)
					self:AddItem(self.misc)
					self.misc:SetName("Misc")

					self.misc:CheckBox("Relative to player", "cl_ctp_offset_relative"):SetTooltip(
					[[If this is off the camera won't follow player angles.
					It's like mayamode in Valve's thirdperson camera]])

					self.misc:CheckBox("Follow pitch", "cl_ctp_offset_lock_z"):SetTooltip(
					[[If this is off, the camera won't follow the player's pitch.
					In other words the camera won't go up and down]])


				self.BaseClass.Init(self)
			end
		end

		do -- ctp_SheetDirection
			local PANEL = vgui.Register("ctp_SheetDirection", {}, "ctp_SheetBase")

			function PANEL:Init()
				self.aim = vgui.Create("ctp_Form", self)
					self:AddItem(self.aim)
					self.aim:SetName("Aim")

					self.aim:NumSlider("Lerp Aim", "cl_ctp_lerp_aim", 0, 100, 2):SetTooltip(
					[[This makes a lerp (blend) between what to aim at.
					0 = player
					50 = what the player sees
					100 the players aim]])

					self.aim:NumSlider("Zoom", "cl_ctp_offset_fov", 0, 150, 2):SetTooltip(
					[[The amount of zoom the camera should do]])

					self.aim:NumSlider("Roll Amount", "cl_ctp_angles_roll_amount", -100, 100, 2):SetTooltip(
					[[This will make the camera roll based on the player's side velocity.
					It obeys direction stiffness]])

				self.zoomdistance = vgui.Create("ctp_Form", self)
					self:AddItem(self.zoomdistance)
					self.zoomdistance:SetName("Zoom Distance")

					self.zoomdistance:CheckBox("Enable", "cl_ctp_offset_fov_zoom_distance_enabled"):SetTooltip(
					[[Enabling this will make the camera zoom in further based on how far the player is from the camera]])

					self.zoomdistance:NumSlider("Distance", "cl_ctp_offset_fov_zoom_distance", 0, 5000, 0):SetTooltip(
					[[The distance for when it should start zooming in]])

					self.zoomdistance:NumSlider("Minimum Zoom", "cl_ctp_offset_fov_zoom_distance_min", 0, 75, 0):SetTooltip(
					[[The minimum distance for distance zooming]])

				self.angles = vgui.Create("ctp_VectorSliders", self)
					self:AddItem(self.angles)
					self.angles:SetMinMax(180)
					self.angles:SetCVars("angles_pitch", "angles_yaw", "angles_roll")
					self.angles:SetText("Angle Offset", "P", "Y", "R",
					[[This controls the angle offset.]])

				self.angleslimit = vgui.Create("ctp_Form", self)
					self:AddItem(self.angleslimit)
					self.angleslimit:SetName("Angle Limit")

					self.angleslimit:CheckBox("Enable", "cl_ctp_angles_limit"):SetTooltip(
					[[Turning this on will make it so the camera tries not to aim away
					from the player	thus making the player always visible. (well it will try to)]])

					self.angleslimit:CheckBox("Smooth", "cl_ctp_angles_limit_smooth"):SetTooltip(
					[[Enabling this will make the angle limit obey direction smoothness]])

				self.BaseClass.Init(self)
			end

		end

		do -- ctp_SheetMisc
			local PANEL = vgui.Register("ctp_SheetMisc", {}, "ctp_SheetBase")

			function PANEL:Init()
				self.player = vgui.Create("ctp_Form")
					self:AddItem(self.player)
					self.player:SetName("Player")

					local entry = self.player:TextEntry("Player Name", "_")
					entry:SetTooltip(
					[[Type in the player's name partially here to change the player used for thirdperson.
					The camera needs to be retoggled.
					To use self, leave blank.]])
					entry.OnEnter = function()
						ctp:SetPlayer(FindPlayerByName(entry:GetValue()))
					end

					entry.UpdateConvarValue = function() end


				self.smoothers = vgui.Create("ctp_Form")
					self:AddItem(self.smoothers)
					self.smoothers:SetName("Stiffness")

					self.smoothers:NumSlider("Position", "cl_ctp_smoother_origin", 0, 40, 2):SetTooltip(
					[[Low values equal slow movement, while high values equal fast movement]])

					self.smoothers:NumSlider("Aim", "cl_ctp_smoother_direction", 0, 40, 2):SetTooltip(
					[[Low values equal slow movement, while high values equal fast movement]])

					self.smoothers:NumSlider("Zoom", "cl_ctp_smoother_fov", 0, 40, 2):SetTooltip(
					[[Low values equal slow movement, while high values equal fast movement]])

				self.center = vgui.Create("ctp_VectorSliders", self)
					self:AddItem(self.center)
					self.center:SetMinMax(300)
					self.center:SetCVars("center_offset_right", "center_offset_forward", "center_offset_up")
					self.center:SetText("Center Offset", "X", "Y", "Z",
					[[This controls where the center of the player is for the camera.]])

					local choice = self.center:MultiChoice("Bone", "cl_ctp_bone_name")
					self:AddItem(self.misc)

					choice:SetTooltip([[This controls the bone the camera will think where the
					player is.]])

					for key in SortedPairs(ctp.BoneList) do
						choice:AddChoice(key)
					end

				self.target = vgui.Create("ctp_Form")
					self:AddItem(self.target)
					self.target:SetName("Targetting")

					self.target:CheckBox("Enable", "cl_ctp_target_enable"):SetTooltip(
					[[Targetting makes it so the camera target props, players and npcs
					If it finds more than one target it will get the center of all found targets
					It's a cinematic effect]])

					self.target:NumSlider("Radius", "cl_ctp_target_radius", 0, 3000, 0):SetTooltip(
					[[The search radius for finding targets]])

					self.target:NumSlider("Blend", "cl_ctp_target_lerp", 0, 100, 2):SetTooltip(
					[[A blend between target and normal aim.

					0 = aim
					100 = target

					so 50 would be in between]])

					self.target:NumSlider("FOV", "cl_ctp_target_fov", 0, 150, 2):SetTooltip(
					[[When targetting is on, it will zoom by this amount]])

				self.rtc = vgui.Create("ctp_Form")
					self:AddItem(self.rtc)
					self.rtc:SetName("Relative Movement")

					self.rtc:CheckBox("Enable", "cl_ctp_movement_rtc_enable"):SetTooltip(
					[[This will make it so you automatically turn relatively to the camera angle]])

					self.rtc:CheckBox("Lock Pitch", "cl_ctp_movement_lock_pitch"):SetTooltip(
					[[This will constantly make your pitch 0]])

					self.rtc:CheckBox("Walk Focus", "cl_ctp_movement_rtc_walk_focus"):SetTooltip(
					[[Enabling this will make the camera aim at the player when walking]])

					self.rtc:NumSlider("Yaw Offset", "cl_ctp_movement_rtc_yaw_offset", -180, 180, 2):SetTooltip(
					[[Offsets the yaw by this angle]])

					self.rtc:NumSlider("Turn Time", "cl_ctp_movement_rtc_turn_time", 0, 15, 3):SetTooltip(
					[[Makes it so you turn this much per frame. Lower is slower, higher is faster.]])

				self.nodes = vgui.Create("ctp_Form")
					self:AddItem(self.nodes)
					self.nodes:SetName("Nodes")

					self.preset = vgui.Create("ctp_Preset")
					self.preset:SetType("nodes")
					self.preset:SetTall(35)
					self.nodes:AddItem(self.preset)
					self.preset:AddTable(ctp:GetNodePresets())
					self.preset.Refresh = function()
						self.preset:AddTable(ctp:GetNodePresets())
					end

					local button = vgui.Create("DButton")

					button:SetText("Clear Nodes")
					button.DoClick = function()
						ctp.Nodes = {}
					end

					self.nodes:AddItem(button)

					self.nodes:CheckBox("Enable", "cl_ctp_nodes_enable"):SetTooltip(
					[[This will enable node cameras. Node cameras are nodes ctp will switch to
					when you are close and seeable by them. It's kind of like silent hill.
					]])

					self.nodes:NumSlider("Stiffness", "cl_ctp_smoother_nodes_direction", 0, 40, 3):SetTooltip(
					[[Makes it so you turn this much per frame. Lower is slower, higher is faster.]])


					self.nodes:CheckBox("Auto Load", "cl_ctp_nodes_load_by_map_name"):SetTooltip(
					[[This will make it so it tries to load a node preset with the same name as the map
					so if you were on gm_construct it would try to load a node preset called "gm_construct" automatically]])

					self.nodes:CheckBox("Enable Placer", "cl_ctp_nodes_place_enable"):SetTooltip(
					[[This enables placing of nodes.
					To Create a node press and hold primary attack, drag it to a desired radius and release.

					to remove a node press secondary attack near the node]])

					self.nodes:CheckBox("Draw Cameras", "cl_ctp_nodes_draw"):SetTooltip(
					[[Draws the node cameras]])

					self.nodes:CheckBox("Draw Spheres", "cl_ctp_nodes_draw_spheres"):SetTooltip(
					[[Draws the radius spheres from the node cameras]])

				self.hud = vgui.Create("ctp_Form")
					self:AddItem(self.hud)
					self.hud:SetName("HUD")

					self.hud:CheckBox("Hide", "cl_ctp_hud_hide"):SetTooltip(
					[[Hides uneeded hud elements. Good for machinimas]])

					self.hud:CheckBox("Crosshair", "cl_ctp_hud_crosshair_enable"):SetTooltip(
					[[Draws a crosshair]])

					self.hud:NumSlider("Crosshair Distance", "cl_ctp_hud_crosshair_distance", 0, 32000, 2):SetTooltip(
					[[The distance of the crosshair from the player in units]])

					self.hud:CheckBox("Black Bars", "cl_ctp_hud_black_bars_enable"):SetTooltip(
					[[Enables black bars which are tied to zoom]])

					self.hud:NumSlider("Black Bars Amount", "cl_ctp_hud_black_bars_amount", 0, 5, 4):SetTooltip(
					[[Controls how much the black bars should lower with zoom]])


				self.BaseClass.Init(self)
			end

		end

		do -- MainFrame
			local PANEL = vgui.Register("ctp_MainFrame", {}, "DFrame")

			function PANEL:Init()
				self.preset = vgui.Create("ctp_Preset", self)
				self.preset:SetType("cvar")
				self.preset:AddTable(ctp:GetCVarPresets())
				self.preset.Refresh = function()
					self.preset:AddTable(ctp:GetCVarPresets())
				end


				self.enable = vgui.Create("DButton", self)
				self.enable:SetText("Toggle")
				self.enable.DoClick = function()
					ctp:Toggle()
				end

				self.sheet = vgui.Create("DPropertySheet", self)
				self.sheet:SetShowIcons(false)

				self.sheet:AddSheet(
					"Position",
					vgui.Create("ctp_SheetOrigin", self),
					nil,
					false,
					false,
					"This sheet is for controlling the position offsets such as where the camera is oriented around the player"
				)

				self.sheet:AddSheet(
					"Aim",
					vgui.Create("ctp_SheetDirection", self),
					nil,
					false,
					false,
					"This sheet is for controlling the aim settings such as where the camera is pointing or/and at what"
				)

				self.sheet:AddSheet(
					"Misc",
					vgui.Create("ctp_SheetMisc", self),
					nil,
					false,
					false,
					"This sheet is for misc options"
				)

				hook.Add("GUIMousePressed", "ctp_gui_GUIMousePressed", function(code)
					local x, y = self:LocalToScreen()

					if
						(
							x + self:GetWide() < gui.MouseX() or
							y + self:GetTall() < gui.MouseY() or
							gui.MouseX() < x or
							gui.MouseY() < y
						) and
						code == MOUSE_LEFT and
						not self.not_focused
					then
						self:KillFocus()
						self:SetMouseInputEnabled(false)
						self:SetKeyBoardInputEnabled(false)
						gui.EnableScreenClicker(false)
						self.not_focused = true
						self:AlphaTo(50, 0.1, 0)

						self.allowclick = false

						timer.Simple(0.2, function()
							self.allowclick = true
						end)

					end
				end)

				hook.Add("StartChat", "ctp_StartChat", function()
					self.ChatEnabled = true
				end)

				hook.Add("FinishChat", "ctp_FinishChat", function()
					timer.Simple(0.1, function() self.ChatEnabled = false end)
				end)

				self.fixbutton = vgui.Create( "DSysButton", self )
				self.fixbutton:SetType( "grip" )
				self.fixbutton.DoClick = function ( )
					self:SetSize(250, 400)
					self:SetSizable(true)
					self:AlignTop(ctp.Spacing)
					self:AlignRight(ctp.Spacing)
					self:SetTall(ScrH() - (ctp.Spacing * 2))
				end
				self.fixbutton:SetDrawBorder( false )
				self.fixbutton:SetDrawBackground( false )
				self.fixbutton:SetTooltip("Defaults the window position and size")

				self.fixbutton:SetSize(15, 15)
				self.btnClose:SetSize(15, 15)

				self:SetSize(250, 400)
				self:SetSizable(true)
				self:AlignTop(ctp.Spacing)
				self:AlignRight(ctp.Spacing)
				self:SetTall(ScrH() - (ctp.Spacing * 2))
				self:SetTitle("CTP Options")
				self:MakePopup()

				self:SetCookieName("ctp_OptionsMenu")

				local x = self:GetCookieNumber("x")
				local y = self:GetCookieNumber("y")
				local w = self:GetCookieNumber("w")
				local h = self:GetCookieNumber("h")

				if x and y and w and h then
					self:SetPos(x,y)
					self:SetWide(w,h)
				end

			end

			function PANEL:PerformLayout()
				DFrame.PerformLayout(self)
				self.sheet:StretchToParent(ctp.Spacing, ctp.Spacing + 90, ctp.Spacing, ctp.Spacing)

				self.enable:MoveAbove(self.sheet, ctp.Spacing)
				self.enable:StretchBottomTo(self.sheet, ctp.Spacing)
				self.enable:AlignLeft(ctp.Spacing)
				self.enable:CopyWidth(self.sheet)

				self.preset:CopyWidth(self.sheet)
				self.preset:AlignTop(ctp.Spacing + 20)
				self.preset:AlignLeft(ctp.Spacing)
				self.preset:StretchBottomTo(self.enable, ctp.Spacing)

				self.fixbutton:AlignTop(2)
				self.fixbutton:MoveLeftOf(self.btnClose, ctp.Spacing)
			end

			function PANEL:Close()
				local x,y = self:GetPos()

				self:SetCookie("x", x)
				self:SetCookie("y", y)
				self:SetCookie("w", self:GetWide())
				self:SetCookie("h", self:GetTall())

				hook.Remove("GUIMousePressed", "ctp_gui_GUIMousePressed")
				hook.Remove("StartChat", "ctp_StartChat")
				hook.Remove("FinishChat", "ctp_FinishChat")
				self:Remove()
			end

			function PANEL:Think()
				DFrame.Think(self)

				if self.allowclick and self.not_focused and vgui.CursorVisible() and not self.ChatEnabled then
					self:MakePopup()
					self.not_focused = false
					self:AlphaTo(255, 0.1, 0)
				end
			end
		end

		do -- ContextMenu
			local PANEL = vgui.Register("ctp_ContextMenu", {}, "DPanel")

			function PANEL:Init()
				self.preset = vgui.Create("ctp_Preset", self)
				self.preset:SetType("cvar")
				self.preset:AddTable(ctp:GetCVarPresets())
				self.preset.Refresh = function()
					self.preset:AddTable(ctp:GetCVarPresets())
				end


				self.enable = vgui.Create("DButton", self)
				self.enable:SetText("Toggle")
				self.enable.DoClick = function()
					ctp:Toggle()
				end

				self.sheet = vgui.Create("DPropertySheet", self)
				self.sheet:SetShowIcons(false)

				self.sheet:AddSheet(
					"Position",
					vgui.Create("ctp_SheetOrigin", self),
					nil,
					false,
					false,
					"This sheet is for controlling the position offsets such as where the camera is oriented around the player"
				)

				self.sheet:AddSheet(
					"Aim",
					vgui.Create("ctp_SheetDirection", self),
					nil,
					false,
					false,
					"This sheet is for controlling the aim settings such as where the camera is pointing or/and at what"
				)

				self.sheet:AddSheet(
					"Misc",
					vgui.Create("ctp_SheetMisc", self),
					nil,
					false,
					false,
					"This sheet is for misc options"
				)

				self:StretchToParent(ctp.Spacing, ctp.Spacing - 350, ctp.Spacing, ctp.Spacing)
			end

			function PANEL:PerformLayout()
				self.sheet:StretchToParent(ctp.Spacing, ctp.Spacing + 90, ctp.Spacing, ctp.Spacing)

				self.enable:MoveAbove(self.sheet, ctp.Spacing)
				self.enable:StretchBottomTo(self.sheet, ctp.Spacing)
				self.enable:AlignLeft(ctp.Spacing)
				self.enable:CopyWidth(self.sheet)

				self.preset:CopyWidth(self.sheet)
				self.preset:AlignTop(ctp.Spacing + 20)
				self.preset:AlignLeft(ctp.Spacing)
				self.preset:StretchBottomTo(self.enable, ctp.Spacing)
			end
		end
	end

end